export default BaseInput;
declare function BaseInput(props: any): (JSX.Element | null)[];
declare namespace BaseInput {
    export const defaultProps: {
        required: boolean;
        disabled: boolean;
        readonly: boolean;
        autofocus: boolean;
    };
    export const propTypes: {
        id: PropTypes.Validator<string>;
        placeholder: PropTypes.Requireable<string>;
        value: PropTypes.Requireable<any>;
        required: PropTypes.Requireable<boolean>;
        disabled: PropTypes.Requireable<boolean>;
        readonly: PropTypes.Requireable<boolean>;
        autofocus: PropTypes.Requireable<boolean>;
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        onBlur: PropTypes.Requireable<(...args: any[]) => any>;
        onFocus: PropTypes.Requireable<(...args: any[]) => any>;
    };
}
import PropTypes from "prop-types";
